diff --git a/src/include/c.h b/src/include/c.h
new file mode 100644
index 10953b3..7a9a797
*** a/src/include/c.h
--- b/src/include/c.h
*************** typedef double float8;
*** 394,412 ****
  typedef Oid regproc;
  typedef regproc RegProcedure;
  
! typedef uint32 TransactionId;
  
! typedef uint32 LocalTransactionId;
  
! typedef uint32 SubTransactionId;
  
  #define InvalidSubTransactionId		((SubTransactionId) 0)
  #define TopSubTransactionId			((SubTransactionId) 1)
  
  /* MultiXactId must be equivalent to TransactionId, to fit in t_xmax */
  typedef TransactionId MultiXactId;
  
! typedef uint32 MultiXactOffset;
  
  typedef uint32 CommandId;
  
--- 394,437 ----
  typedef Oid regproc;
  typedef regproc RegProcedure;
  
! /* Macro for checking XID 64-bitness */
! #define XID_IS_64BIT
  
! #define MAX_START_XID	UINT64CONST(0x3fffffffffffffff)
  
! typedef uint64 TransactionId;
! 
! #define TransactionIdPrecedes(id1, id2) ((id1) < (id2))
! #define TransactionIdPrecedesOrEquals(id1, id2) ((id1) <= (id2))
! #define TransactionIdFollows(id1, id2) ((id1) > (id2))
! #define TransactionIdFollowsOrEquals(id1, id2) ((id1) >= (id2))
! 
! #define StartTransactionIdIsValid(start_xid)	((start_xid) <= MAX_START_XID)
! 
! typedef uint32 ShortTransactionId;
! 
! typedef uint64 LocalTransactionId;
! 
! typedef uint64 SubTransactionId;
  
  #define InvalidSubTransactionId		((SubTransactionId) 0)
  #define TopSubTransactionId			((SubTransactionId) 1)
  
+ #define XID_FMT UINT64_FORMAT
+ 
  /* MultiXactId must be equivalent to TransactionId, to fit in t_xmax */
  typedef TransactionId MultiXactId;
  
! #define MultiXactIdPrecedes(id1, id2) ((id1) < (id2))
! #define MultiXactIdPrecedesOrEquals(id1, id2) ((id1) <= (id2))
! #define MultiXactIdFollows(id1, id2) ((id1) > (id2))
! #define MultiXactIdFollowsOrEquals(id1, id2) ((id1) >= (id2))
! 
! #define StartMultiXactIdIsValid(start_mx_id)	((start_mx_id) <= MAX_START_XID)
! 
! typedef uint64 MultiXactOffset;
! 
! #define StartMultiXactOffsetIsValid(start_mx_offset)	((start_mx_offset) <= MAX_START_XID)
  
  typedef uint32 CommandId;
  
diff --git a/src/include/catalog/pg_control.h b/src/include/catalog/pg_control.h
new file mode 100644
index 3a25cc8..10899d9
*** a/src/include/catalog/pg_control.h
--- b/src/include/catalog/pg_control.h
*************** typedef struct CheckPoint
*** 38,44 ****
  	TimeLineID	PrevTimeLineID; /* previous TLI, if this record begins a new
  								 * timeline (equals ThisTimeLineID otherwise) */
  	bool		fullPageWrites; /* current full_page_writes */
- 	uint32		nextXidEpoch;	/* higher-order bits of nextXid */
  	TransactionId nextXid;		/* next free XID */
  	Oid			nextOid;		/* next free OID */
  	MultiXactId nextMulti;		/* next free MultiXactId */
--- 38,43 ----
diff --git a/src/include/catalog/pg_operator.h b/src/include/catalog/pg_operator.h
new file mode 100644
index ccbb17e..0d3440d
*** a/src/include/catalog/pg_operator.h
--- b/src/include/catalog/pg_operator.h
*************** DESCR("concatenate");
*** 144,154 ****
  
  DATA(insert OID = 352 (  "="	   PGNSP PGUID b f t	28	28	16	352   3315 xideq eqsel eqjoinsel ));
  DESCR("equal");
! DATA(insert OID = 353 (  "="	   PGNSP PGUID b f f	28	23	16	0	  3316 xideqint4 eqsel eqjoinsel ));
  DESCR("equal");
  DATA(insert OID = 3315 (  "<>"	   PGNSP PGUID b f f	28	28	16	3315   352 xidneq neqsel neqjoinsel ));
  DESCR("not equal");
! DATA(insert OID = 3316 (  "<>"	   PGNSP PGUID b f f	28	23	16	0	   353 xidneqint4 neqsel neqjoinsel ));
  DESCR("not equal");
  DATA(insert OID = 388 (  "!"	   PGNSP PGUID r f f	20	 0	1700  0  0 numeric_fac - - ));
  DESCR("factorial");
--- 144,154 ----
  
  DATA(insert OID = 352 (  "="	   PGNSP PGUID b f t	28	28	16	352   3315 xideq eqsel eqjoinsel ));
  DESCR("equal");
! DATA(insert OID = 353 (  "="	   PGNSP PGUID b f f	28	20	16	0	  3316 xideqint8 eqsel eqjoinsel ));
  DESCR("equal");
  DATA(insert OID = 3315 (  "<>"	   PGNSP PGUID b f f	28	28	16	3315   352 xidneq neqsel neqjoinsel ));
  DESCR("not equal");
! DATA(insert OID = 3316 (  "<>"	   PGNSP PGUID b f f	28	20	16	0	   353 xidneqint8 neqsel neqjoinsel ));
  DESCR("not equal");
  DATA(insert OID = 388 (  "!"	   PGNSP PGUID r f f	20	 0	1700  0  0 numeric_fac - - ));
  DESCR("factorial");
diff --git a/src/include/catalog/pg_proc.h b/src/include/catalog/pg_proc.h
new file mode 100644
index 6c44def..ff4385f
*** a/src/include/catalog/pg_proc.h
--- b/src/include/catalog/pg_proc.h
*************** DESCR("length");
*** 1437,1444 ****
  DATA(insert OID = 1318 (  length			 PGNSP PGUID 12 1 0 0 0 f f f f t f i s 1 0 23 "1042" _null_ _null_ _null_ _null_ _null_ bpcharlen _null_ _null_ _null_ ));
  DESCR("character length");
  
! DATA(insert OID = 1319 (  xideqint4			 PGNSP PGUID 12 1 0 0 0 f f f t t f i s 2 0 16 "28 23" _null_ _null_ _null_ _null_ _null_ xideq _null_ _null_ _null_ ));
! DATA(insert OID = 3309 (  xidneqint4		 PGNSP PGUID 12 1 0 0 0 f f f t t f i s 2 0 16 "28 23" _null_ _null_ _null_ _null_ _null_ xidneq _null_ _null_ _null_ ));
  
  DATA(insert OID = 1326 (  interval_div		 PGNSP PGUID 12 1 0 0 0 f f f f t f i s 2 0 1186 "1186 701" _null_ _null_ _null_ _null_ _null_	interval_div _null_ _null_ _null_ ));
  
--- 1437,1444 ----
  DATA(insert OID = 1318 (  length			 PGNSP PGUID 12 1 0 0 0 f f f f t f i s 1 0 23 "1042" _null_ _null_ _null_ _null_ _null_ bpcharlen _null_ _null_ _null_ ));
  DESCR("character length");
  
! DATA(insert OID = 1319 (  xideqint8			 PGNSP PGUID 12 1 0 0 0 f f f t t f i s 2 0 16 "28 20" _null_ _null_ _null_ _null_ _null_ xideq _null_ _null_ _null_ ));
! DATA(insert OID = 3309 (  xidneqint8		 PGNSP PGUID 12 1 0 0 0 f f f t t f i s 2 0 16 "28 20" _null_ _null_ _null_ _null_ _null_ xidneq _null_ _null_ _null_ ));
  
  DATA(insert OID = 1326 (  interval_div		 PGNSP PGUID 12 1 0 0 0 f f f f t f i s 2 0 1186 "1186 701" _null_ _null_ _null_ _null_ _null_	interval_div _null_ _null_ _null_ ));
  
diff --git a/src/include/catalog/pg_type.h b/src/include/catalog/pg_type.h
new file mode 100644
index 345e916..894282c
*** a/src/include/catalog/pg_type.h
--- b/src/include/catalog/pg_type.h
*************** DATA(insert OID = 27 (	tid		   PGNSP PGU
*** 331,337 ****
  DESCR("(block, offset), physical location of tuple");
  #define TIDOID		27
  
! DATA(insert OID = 28 (	xid		   PGNSP PGUID	4 t b U f t \054 0	 0 1011 xidin xidout xidrecv xidsend - - - i p f 0 -1 0 0 _null_ _null_ _null_ ));
  DESCR("transaction id");
  #define XIDOID 28
  
--- 331,337 ----
  DESCR("(block, offset), physical location of tuple");
  #define TIDOID		27
  
! DATA(insert OID = 28 (	xid		   PGNSP PGUID	8 FLOAT8PASSBYVAL b U f t \054 0	 0 1011 xidin xidout xidrecv xidsend - - - d p f 0 -1 0 0 _null_ _null_ _null_ ));
  DESCR("transaction id");
  #define XIDOID 28
  
*************** DATA(insert OID = 1009 (  _text		 PGNSP 
*** 471,477 ****
  DATA(insert OID = 1028 (  _oid		 PGNSP PGUID -1 f b A f t \054 0	26 0 array_in array_out array_recv array_send - - array_typanalyze i x f 0 -1 0 0 _null_ _null_ _null_ ));
  #define OIDARRAYOID			1028
  DATA(insert OID = 1010 (  _tid		 PGNSP PGUID -1 f b A f t \054 0	27 0 array_in array_out array_recv array_send - - array_typanalyze i x f 0 -1 0 0 _null_ _null_ _null_ ));
! DATA(insert OID = 1011 (  _xid		 PGNSP PGUID -1 f b A f t \054 0	28 0 array_in array_out array_recv array_send - - array_typanalyze i x f 0 -1 0 0 _null_ _null_ _null_ ));
  DATA(insert OID = 1012 (  _cid		 PGNSP PGUID -1 f b A f t \054 0	29 0 array_in array_out array_recv array_send - - array_typanalyze i x f 0 -1 0 0 _null_ _null_ _null_ ));
  DATA(insert OID = 1013 (  _oidvector PGNSP PGUID -1 f b A f t \054 0	30 0 array_in array_out array_recv array_send - - array_typanalyze i x f 0 -1 0 0 _null_ _null_ _null_ ));
  DATA(insert OID = 1014 (  _bpchar	 PGNSP PGUID -1 f b A f t \054 0 1042 0 array_in array_out array_recv array_send bpchartypmodin bpchartypmodout array_typanalyze i x f 0 -1 0 100 _null_ _null_ _null_ ));
--- 471,477 ----
  DATA(insert OID = 1028 (  _oid		 PGNSP PGUID -1 f b A f t \054 0	26 0 array_in array_out array_recv array_send - - array_typanalyze i x f 0 -1 0 0 _null_ _null_ _null_ ));
  #define OIDARRAYOID			1028
  DATA(insert OID = 1010 (  _tid		 PGNSP PGUID -1 f b A f t \054 0	27 0 array_in array_out array_recv array_send - - array_typanalyze i x f 0 -1 0 0 _null_ _null_ _null_ ));
! DATA(insert OID = 1011 (  _xid		 PGNSP PGUID -1 f b A f t \054 0	28 0 array_in array_out array_recv array_send - - array_typanalyze d x f 0 -1 0 0 _null_ _null_ _null_ ));
  DATA(insert OID = 1012 (  _cid		 PGNSP PGUID -1 f b A f t \054 0	29 0 array_in array_out array_recv array_send - - array_typanalyze i x f 0 -1 0 0 _null_ _null_ _null_ ));
  DATA(insert OID = 1013 (  _oidvector PGNSP PGUID -1 f b A f t \054 0	30 0 array_in array_out array_recv array_send - - array_typanalyze i x f 0 -1 0 0 _null_ _null_ _null_ ));
  DATA(insert OID = 1014 (  _bpchar	 PGNSP PGUID -1 f b A f t \054 0 1042 0 array_in array_out array_recv array_send bpchartypmodin bpchartypmodout array_typanalyze i x f 0 -1 0 100 _null_ _null_ _null_ ));
diff --git a/src/include/commands/sequence.h b/src/include/commands/sequence.h
new file mode 100644
index 304586e..eb805ff
*** a/src/include/commands/sequence.h
--- b/src/include/commands/sequence.h
*************** typedef FormData_pg_sequence_data *Form_
*** 45,50 ****
--- 45,55 ----
  /* XLOG stuff */
  #define XLOG_SEQ_LOG			0x00
  
+ /*
+  * The "special area" of a sequence's buffer page looks like this.
+  */
+ #define SEQ_MAGIC	  0x1717
+ 
  typedef struct xl_seq_rec
  {
  	RelFileNode node;
diff --git a/src/include/commands/vacuum.h b/src/include/commands/vacuum.h
new file mode 100644
index 541c2fa..903d6db
*** a/src/include/commands/vacuum.h
--- b/src/include/commands/vacuum.h
*************** typedef struct VacAttrStats
*** 135,145 ****
   */
  typedef struct VacuumParams
  {
! 	int			freeze_min_age; /* min freeze age, -1 to use default */
! 	int			freeze_table_age;		/* age at which to scan whole table */
! 	int			multixact_freeze_min_age;		/* min multixact freeze age,
  												 * -1 to use default */
! 	int			multixact_freeze_table_age;		/* multixact age at which to
  												 * scan whole table */
  	bool		is_wraparound;	/* force a for-wraparound vacuum */
  	int			log_min_duration;		/* minimum execution threshold in ms
--- 135,145 ----
   */
  typedef struct VacuumParams
  {
! 	int64		freeze_min_age; /* min freeze age, -1 to use default */
! 	int64		freeze_table_age;		/* age at which to scan whole table */
! 	int64		multixact_freeze_min_age;		/* min multixact freeze age,
  												 * -1 to use default */
! 	int64		multixact_freeze_table_age;		/* multixact age at which to
  												 * scan whole table */
  	bool		is_wraparound;	/* force a for-wraparound vacuum */
  	int			log_min_duration;		/* minimum execution threshold in ms
*************** typedef struct VacuumParams
*** 150,159 ****
  /* GUC parameters */
  extern PGDLLIMPORT int default_statistics_target;		/* PGDLLIMPORT for
  														 * PostGIS */
! extern int	vacuum_freeze_min_age;
! extern int	vacuum_freeze_table_age;
! extern int	vacuum_multixact_freeze_min_age;
! extern int	vacuum_multixact_freeze_table_age;
  
  
  /* in commands/vacuum.c */
--- 150,159 ----
  /* GUC parameters */
  extern PGDLLIMPORT int default_statistics_target;		/* PGDLLIMPORT for
  														 * PostGIS */
! extern int64	vacuum_freeze_min_age;
! extern int64	vacuum_freeze_table_age;
! extern int64	vacuum_multixact_freeze_min_age;
! extern int64	vacuum_multixact_freeze_table_age;
  
  
  /* in commands/vacuum.c */
*************** extern void vac_update_relstats(Relation
*** 177,185 ****
  					MultiXactId minmulti,
  					bool in_outer_xact);
  extern void vacuum_set_xid_limits(Relation rel,
! 					  int freeze_min_age, int freeze_table_age,
! 					  int multixact_freeze_min_age,
! 					  int multixact_freeze_table_age,
  					  TransactionId *oldestXmin,
  					  TransactionId *freezeLimit,
  					  TransactionId *xidFullScanLimit,
--- 177,185 ----
  					MultiXactId minmulti,
  					bool in_outer_xact);
  extern void vacuum_set_xid_limits(Relation rel,
! 					  int64 freeze_min_age, int64 freeze_table_age,
! 					  int64 multixact_freeze_min_age,
! 					  int64 multixact_freeze_table_age,
  					  TransactionId *oldestXmin,
  					  TransactionId *freezeLimit,
  					  TransactionId *xidFullScanLimit,
diff --git a/src/include/fmgr.h b/src/include/fmgr.h
new file mode 100644
index cfb7b77..c8e769b
*** a/src/include/fmgr.h
--- b/src/include/fmgr.h
*************** extern struct varlena *pg_detoast_datum_
*** 245,250 ****
--- 245,251 ----
  #define PG_GETARG_FLOAT4(n)  DatumGetFloat4(PG_GETARG_DATUM(n))
  #define PG_GETARG_FLOAT8(n)  DatumGetFloat8(PG_GETARG_DATUM(n))
  #define PG_GETARG_INT64(n)	 DatumGetInt64(PG_GETARG_DATUM(n))
+ #define PG_GETARG_TRANSACTIONID(n)	DatumGetTransactionId(PG_GETARG_DATUM(n))
  /* use this if you want the raw, possibly-toasted input datum: */
  #define PG_GETARG_RAW_VARLENA_P(n)	((struct varlena *) PG_GETARG_POINTER(n))
  /* use this if you want the input datum de-toasted: */
*************** extern struct varlena *pg_detoast_datum_
*** 325,330 ****
--- 326,332 ----
  #define PG_RETURN_FLOAT4(x)  return Float4GetDatum(x)
  #define PG_RETURN_FLOAT8(x)  return Float8GetDatum(x)
  #define PG_RETURN_INT64(x)	 return Int64GetDatum(x)
+ #define PG_RETURN_TRANSACTIONID(x)	return TransactionIdGetDatum(x)
  /* RETURN macros for other pass-by-ref types will typically look like this: */
  #define PG_RETURN_BYTEA_P(x)   PG_RETURN_POINTER(x)
  #define PG_RETURN_TEXT_P(x)    PG_RETURN_POINTER(x)
diff --git a/src/include/postgres.h b/src/include/postgres.h
new file mode 100644
index 009337d..0bf885a
*** a/src/include/postgres.h
--- b/src/include/postgres.h
*************** typedef Datum *DatumPtr;
*** 517,537 ****
   *		Returns transaction identifier value of a datum.
   */
  
! #define DatumGetTransactionId(X) ((TransactionId) GET_4_BYTES(X))
  
  /*
   * TransactionIdGetDatum
   *		Returns datum representation for a transaction identifier.
   */
  
! #define TransactionIdGetDatum(X) ((Datum) SET_4_BYTES((X)))
  
  /*
   * MultiXactIdGetDatum
   *		Returns datum representation for a multixact identifier.
   */
  
! #define MultiXactIdGetDatum(X) ((Datum) SET_4_BYTES((X)))
  
  /*
   * DatumGetCommandId
--- 517,537 ----
   *		Returns transaction identifier value of a datum.
   */
  
! #define DatumGetTransactionId(X) (DatumGetUInt64(X))
  
  /*
   * TransactionIdGetDatum
   *		Returns datum representation for a transaction identifier.
   */
  
! #define TransactionIdGetDatum(X) (UInt64GetDatum(X))
  
  /*
   * MultiXactIdGetDatum
   *		Returns datum representation for a multixact identifier.
   */
  
! #define MultiXactIdGetDatum(X) (UInt64GetDatum(X))
  
  /*
   * DatumGetCommandId
diff --git a/src/include/postmaster/autovacuum.h b/src/include/postmaster/autovacuum.h
new file mode 100644
index d383fd3..6590790
*** a/src/include/postmaster/autovacuum.h
--- b/src/include/postmaster/autovacuum.h
*************** extern int	autovacuum_vac_thresh;
*** 35,42 ****
  extern double autovacuum_vac_scale;
  extern int	autovacuum_anl_thresh;
  extern double autovacuum_anl_scale;
! extern int	autovacuum_freeze_max_age;
! extern int	autovacuum_multixact_freeze_max_age;
  extern int	autovacuum_vac_cost_delay;
  extern int	autovacuum_vac_cost_limit;
  
--- 35,42 ----
  extern double autovacuum_vac_scale;
  extern int	autovacuum_anl_thresh;
  extern double autovacuum_anl_scale;
! extern int64 autovacuum_freeze_max_age;
! extern int64 autovacuum_multixact_freeze_max_age;
  extern int	autovacuum_vac_cost_delay;
  extern int	autovacuum_vac_cost_limit;
  
diff --git a/src/include/storage/bufpage.h b/src/include/storage/bufpage.h
new file mode 100644
index 4535ce9..6061c54
*** a/src/include/storage/bufpage.h
--- b/src/include/storage/bufpage.h
*************** typedef struct PageHeaderData
*** 156,164 ****
--- 156,167 ----
  
  typedef PageHeaderData *PageHeader;
  
+ 
  /*
   * HeapPageSpecialData -- data that stored at the end of each heap page.
   *
+  *		pd_xid_base - base value for transaction IDs on page
+  *		pd_multi_base - base value for multixact IDs on page
   *		pd_prune_xid - oldest XID among potentially prunable tuples on page.
   *		pd_magic - magic number identifies type of page
   *
*************** typedef PageHeaderData *PageHeader;
*** 170,177 ****
   */
  typedef struct HeapPageSpecialData
  {
! 	TransactionId		pd_prune_xid; /* oldest prunable XID, or zero if none */
! 	uint32				pd_magic;	  /* magic number identifies type of page */
  } HeapPageSpecialData;
  
  /*
--- 173,182 ----
   */
  typedef struct HeapPageSpecialData
  {
! 	TransactionId		pd_xid_base;   /* base value for transaction IDs on page */
! 	TransactionId		pd_multi_base; /* base value for multixact IDs on page */
! 	TransactionId		pd_prune_xid;  /* oldest prunable XID, or zero if none */
! 	uint32				pd_magic;	   /* magic number identifies type of page */
  } HeapPageSpecialData;
  
  /*
*************** typedef HeapPageSpecialData *HeapPageSpe
*** 192,197 ****
--- 197,212 ----
  	(HeapPageSpecial) ((Pointer) page + BLCKSZ - MAXALIGN(sizeof(HeapPageSpecialData))) \
  )
  
+ #define HeapPageSetPruneXid(page, xid) \
+ ( \
+ 	HeapPageGetSpecial(page)->pd_prune_xid = NormalTransactionIdToShort(HeapPageGetSpecial(page)->pd_xid_base, (xid)) \
+ )
+ 
+ #define HeapPageGetPruneXid(page) \
+ ( \
+ 	ShortTransactionIdToNormal(HeapPageGetSpecial(page)->pd_xid_base, HeapPageGetSpecial(page)->pd_prune_xid) \
+ )
+ 
  /*
   * pd_flags contains the following flag bits.  Undefined bits are initialized
   * to zero and may be used in the future.
*************** PageValidateSpecialPointer(Page page)
*** 420,437 ****
  #define PageIsPrunable(page, oldestxmin) \
  ( \
  	AssertMacro(TransactionIdIsNormal(oldestxmin)), \
! 	TransactionIdIsValid(HeapPageGetSpecial(page)->pd_prune_xid) && \
! 	TransactionIdPrecedes(HeapPageGetSpecial(page)->pd_prune_xid, oldestxmin) \
  )
  #define PageSetPrunable(page, xid) \
  do { \
  	Assert(TransactionIdIsNormal(xid)); \
! 	if (!TransactionIdIsValid(HeapPageGetSpecial(page)->pd_prune_xid) || \
! 		TransactionIdPrecedes(xid, HeapPageGetSpecial(page)->pd_prune_xid)) \
! 		HeapPageGetSpecial(page)->pd_prune_xid = (xid); \
  } while (0)
  #define PageClearPrunable(page) \
! 	(HeapPageGetSpecial(page)->pd_prune_xid = InvalidTransactionId)
  
  
  /* ----------------------------------------------------------------
--- 435,452 ----
  #define PageIsPrunable(page, oldestxmin) \
  ( \
  	AssertMacro(TransactionIdIsNormal(oldestxmin)), \
! 	TransactionIdIsValid(HeapPageGetPruneXid(page)) && \
! 	TransactionIdPrecedes(HeapPageGetPruneXid(page), oldestxmin) \
  )
  #define PageSetPrunable(page, xid) \
  do { \
  	Assert(TransactionIdIsNormal(xid)); \
! 	if (!TransactionIdIsValid(HeapPageGetPruneXid(page)) || \
! 		TransactionIdPrecedes(xid, HeapPageGetPruneXid(page))) \
! 		HeapPageSetPruneXid(page, xid); \
  } while (0)
  #define PageClearPrunable(page) \
! 	(HeapPageSetPruneXid(page, InvalidTransactionId))
  
  
  /* ----------------------------------------------------------------
diff --git a/src/include/storage/lock.h b/src/include/storage/lock.h
new file mode 100644
index 7a9c105..69c2398
*** a/src/include/storage/lock.h
--- b/src/include/storage/lock.h
*************** typedef struct LOCKTAG
*** 224,231 ****
  	 (locktag).locktag_lockmethodid = DEFAULT_LOCKMETHOD)
  
  #define SET_LOCKTAG_TRANSACTION(locktag,xid) \
! 	((locktag).locktag_field1 = (xid), \
! 	 (locktag).locktag_field2 = 0, \
  	 (locktag).locktag_field3 = 0, \
  	 (locktag).locktag_field4 = 0, \
  	 (locktag).locktag_type = LOCKTAG_TRANSACTION, \
--- 224,231 ----
  	 (locktag).locktag_lockmethodid = DEFAULT_LOCKMETHOD)
  
  #define SET_LOCKTAG_TRANSACTION(locktag,xid) \
! 	((locktag).locktag_field1 = (uint32)((xid) & 0xFFFFFFFF), \
! 	 (locktag).locktag_field2 = (uint32)((xid) >> 32), \
  	 (locktag).locktag_field3 = 0, \
  	 (locktag).locktag_field4 = 0, \
  	 (locktag).locktag_type = LOCKTAG_TRANSACTION, \
*************** typedef struct LOCKTAG
*** 233,248 ****
  
  #define SET_LOCKTAG_VIRTUALTRANSACTION(locktag,vxid) \
  	((locktag).locktag_field1 = (vxid).backendId, \
! 	 (locktag).locktag_field2 = (vxid).localTransactionId, \
! 	 (locktag).locktag_field3 = 0, \
  	 (locktag).locktag_field4 = 0, \
  	 (locktag).locktag_type = LOCKTAG_VIRTUALTRANSACTION, \
  	 (locktag).locktag_lockmethodid = DEFAULT_LOCKMETHOD)
  
  #define SET_LOCKTAG_SPECULATIVE_INSERTION(locktag,xid,token) \
! 	((locktag).locktag_field1 = (xid), \
! 	 (locktag).locktag_field2 = (token),		\
! 	 (locktag).locktag_field3 = 0, \
  	 (locktag).locktag_field4 = 0, \
  	 (locktag).locktag_type = LOCKTAG_SPECULATIVE_TOKEN, \
  	 (locktag).locktag_lockmethodid = DEFAULT_LOCKMETHOD)
--- 233,248 ----
  
  #define SET_LOCKTAG_VIRTUALTRANSACTION(locktag,vxid) \
  	((locktag).locktag_field1 = (vxid).backendId, \
! 	 (locktag).locktag_field2 = (uint32)((vxid).localTransactionId & 0xFFFFFFFF), \
! 	 (locktag).locktag_field3 = (uint32)((vxid).localTransactionId >> 32), \
  	 (locktag).locktag_field4 = 0, \
  	 (locktag).locktag_type = LOCKTAG_VIRTUALTRANSACTION, \
  	 (locktag).locktag_lockmethodid = DEFAULT_LOCKMETHOD)
  
  #define SET_LOCKTAG_SPECULATIVE_INSERTION(locktag,xid,token) \
! 	((locktag).locktag_field1 = (uint32)((xid) & 0xFFFFFFFF), \
! 	 (locktag).locktag_field2 = (uint32)((xid) >> 32), \
! 	 (locktag).locktag_field3 = (token),		\
  	 (locktag).locktag_field4 = 0, \
  	 (locktag).locktag_type = LOCKTAG_SPECULATIVE_TOKEN, \
  	 (locktag).locktag_lockmethodid = DEFAULT_LOCKMETHOD)
diff --git a/src/include/storage/standby.h b/src/include/storage/standby.h
new file mode 100644
index 3ecc446..f36cb8f
*** a/src/include/storage/standby.h
--- b/src/include/storage/standby.h
***************
*** 20,26 ****
  #include "storage/relfilenode.h"
  
  /* User-settable GUC parameters */
! extern int	vacuum_defer_cleanup_age;
  extern int	max_standby_archive_delay;
  extern int	max_standby_streaming_delay;
  
--- 20,26 ----
  #include "storage/relfilenode.h"
  
  /* User-settable GUC parameters */
! extern int64 vacuum_defer_cleanup_age;
  extern int	max_standby_archive_delay;
  extern int	max_standby_streaming_delay;
  
diff --git a/src/include/utils/rel.h b/src/include/utils/rel.h
new file mode 100644
index 8476896..3dc7d40
*** a/src/include/utils/rel.h
--- b/src/include/utils/rel.h
*************** typedef struct AutoVacOpts
*** 262,273 ****
  	int			analyze_threshold;
  	int			vacuum_cost_delay;
  	int			vacuum_cost_limit;
! 	int			freeze_min_age;
! 	int			freeze_max_age;
! 	int			freeze_table_age;
! 	int			multixact_freeze_min_age;
! 	int			multixact_freeze_max_age;
! 	int			multixact_freeze_table_age;
  	int			log_min_duration;
  	float8		vacuum_scale_factor;
  	float8		analyze_scale_factor;
--- 262,273 ----
  	int			analyze_threshold;
  	int			vacuum_cost_delay;
  	int			vacuum_cost_limit;
! 	int64		freeze_min_age;
! 	int64		freeze_max_age;
! 	int64		freeze_table_age;
! 	int64		multixact_freeze_min_age;
! 	int64		multixact_freeze_max_age;
! 	int64		multixact_freeze_table_age;
  	int			log_min_duration;
  	float8		vacuum_scale_factor;
  	float8		analyze_scale_factor;
diff --git a/src/include/utils/tqual.h b/src/include/utils/tqual.h
new file mode 100644
index f39f21b..51c4262
*** a/src/include/utils/tqual.h
--- b/src/include/utils/tqual.h
*************** extern bool HeapTupleIsSurelyDead(HeapTu
*** 79,85 ****
  
  extern void HeapTupleSetHintBits(HeapTupleHeader tuple, Buffer buffer,
  					 uint16 infomask, TransactionId xid);
! extern bool HeapTupleHeaderIsOnlyLocked(HeapTupleHeader tuple);
  
  /*
   * To avoid leaking too much knowledge about reorderbuffer implementation
--- 79,85 ----
  
  extern void HeapTupleSetHintBits(HeapTupleHeader tuple, Buffer buffer,
  					 uint16 infomask, TransactionId xid);
! extern bool HeapTupleHeaderIsOnlyLocked(HeapTuple tuple);
  
  /*
   * To avoid leaking too much knowledge about reorderbuffer implementation
diff --git a/src/pl/plperl/plperl.c b/src/pl/plperl/plperl.c
new file mode 100644
index ce72dd4..304404a
*** a/src/pl/plperl/plperl.c
--- b/src/pl/plperl/plperl.c
*************** validate_plperl_function(plperl_proc_ptr
*** 2598,2604 ****
  		 * This is needed because CREATE OR REPLACE FUNCTION can modify the
  		 * function's pg_proc entry without changing its OID.
  		 ************************************************************/
! 		uptodate = (prodesc->fn_xmin == HeapTupleHeaderGetRawXmin(procTup->t_data) &&
  					ItemPointerEquals(&prodesc->fn_tid, &procTup->t_self));
  
  		if (uptodate)
--- 2598,2604 ----
  		 * This is needed because CREATE OR REPLACE FUNCTION can modify the
  		 * function's pg_proc entry without changing its OID.
  		 ************************************************************/
! 		uptodate = (prodesc->fn_xmin == HeapTupleGetRawXmin(procTup) &&
  					ItemPointerEquals(&prodesc->fn_tid, &procTup->t_self));
  
  		if (uptodate)
*************** compile_plperl_function(Oid fn_oid, bool
*** 2721,2727 ****
  		prodesc->proname = pstrdup(NameStr(procStruct->proname));
  		prodesc->fn_cxt = proc_cxt;
  		prodesc->fn_refcount = 0;
! 		prodesc->fn_xmin = HeapTupleHeaderGetRawXmin(procTup->t_data);
  		prodesc->fn_tid = procTup->t_self;
  		prodesc->nargs = procStruct->pronargs;
  		prodesc->arg_out_func = (FmgrInfo *) palloc0(prodesc->nargs * sizeof(FmgrInfo));
--- 2721,2727 ----
  		prodesc->proname = pstrdup(NameStr(procStruct->proname));
  		prodesc->fn_cxt = proc_cxt;
  		prodesc->fn_refcount = 0;
! 		prodesc->fn_xmin = HeapTupleGetRawXmin(procTup);
  		prodesc->fn_tid = procTup->t_self;
  		prodesc->nargs = procStruct->pronargs;
  		prodesc->arg_out_func = (FmgrInfo *) palloc0(prodesc->nargs * sizeof(FmgrInfo));
diff --git a/src/pl/plpgsql/src/pl_comp.c b/src/pl/plpgsql/src/pl_comp.c
new file mode 100644
index cc09355..6c5d3aa
*** a/src/pl/plpgsql/src/pl_comp.c
--- b/src/pl/plpgsql/src/pl_comp.c
*************** recheck:
*** 172,178 ****
  	if (function)
  	{
  		/* We have a compiled function, but is it still valid? */
! 		if (function->fn_xmin == HeapTupleHeaderGetRawXmin(procTup->t_data) &&
  			ItemPointerEquals(&function->fn_tid, &procTup->t_self))
  			function_valid = true;
  		else
--- 172,178 ----
  	if (function)
  	{
  		/* We have a compiled function, but is it still valid? */
! 		if (function->fn_xmin == HeapTupleGetRawXmin(procTup) &&
  			ItemPointerEquals(&function->fn_tid, &procTup->t_self))
  			function_valid = true;
  		else
*************** do_compile(FunctionCallInfo fcinfo,
*** 348,354 ****
  
  	function->fn_signature = format_procedure(fcinfo->flinfo->fn_oid);
  	function->fn_oid = fcinfo->flinfo->fn_oid;
! 	function->fn_xmin = HeapTupleHeaderGetRawXmin(procTup->t_data);
  	function->fn_tid = procTup->t_self;
  	function->fn_input_collation = fcinfo->fncollation;
  	function->fn_cxt = func_cxt;
--- 348,354 ----
  
  	function->fn_signature = format_procedure(fcinfo->flinfo->fn_oid);
  	function->fn_oid = fcinfo->flinfo->fn_oid;
! 	function->fn_xmin = HeapTupleGetRawXmin(procTup);
  	function->fn_tid = procTup->t_self;
  	function->fn_input_collation = fcinfo->fncollation;
  	function->fn_cxt = func_cxt;
diff --git a/src/pl/plpgsql/src/pl_exec.c b/src/pl/plpgsql/src/pl_exec.c
new file mode 100644
index 7a40c99..06596d4
*** a/src/pl/plpgsql/src/pl_exec.c
--- b/src/pl/plpgsql/src/pl_exec.c
*************** get_tuple_from_datum(Datum value)
*** 6142,6147 ****
--- 6142,6148 ----
  	tmptup.t_len = HeapTupleHeaderGetDatumLength(td);
  	ItemPointerSetInvalid(&(tmptup.t_self));
  	tmptup.t_tableOid = InvalidOid;
+ 	HeapTupleSetZeroBase(&tmptup);
  	tmptup.t_data = td;
  
  	/* Build a copy and return it */
*************** exec_move_row_from_datum(PLpgSQL_execsta
*** 6198,6203 ****
--- 6199,6205 ----
  	tmptup.t_len = HeapTupleHeaderGetDatumLength(td);
  	ItemPointerSetInvalid(&(tmptup.t_self));
  	tmptup.t_tableOid = InvalidOid;
+ 	HeapTupleSetZeroBase(&tmptup);
  	tmptup.t_data = td;
  
  	/* Do the move */
diff --git a/src/pl/plpython/plpy_procedure.c b/src/pl/plpython/plpy_procedure.c
new file mode 100644
index e86117c..d45a5f6
*** a/src/pl/plpython/plpy_procedure.c
--- b/src/pl/plpython/plpy_procedure.c
*************** PLy_procedure_create(HeapTuple procTup, 
*** 184,190 ****
  
  		proc->proname = pstrdup(NameStr(procStruct->proname));
  		proc->pyname = pstrdup(procName);
! 		proc->fn_xmin = HeapTupleHeaderGetRawXmin(procTup->t_data);
  		proc->fn_tid = procTup->t_self;
  		proc->fn_readonly = (procStruct->provolatile != PROVOLATILE_VOLATILE);
  		proc->is_setof = procStruct->proretset;
--- 184,190 ----
  
  		proc->proname = pstrdup(NameStr(procStruct->proname));
  		proc->pyname = pstrdup(procName);
! 		proc->fn_xmin = HeapTupleGetRawXmin(procTup);
  		proc->fn_tid = procTup->t_self;
  		proc->fn_readonly = (procStruct->provolatile != PROVOLATILE_VOLATILE);
  		proc->is_setof = procStruct->proretset;
*************** PLy_procedure_argument_valid(PLyTypeInfo
*** 455,461 ****
  		elog(ERROR, "cache lookup failed for relation %u", arg->typ_relid);
  
  	/* If it has changed, the cached data is not valid */
! 	valid = (arg->typrel_xmin == HeapTupleHeaderGetRawXmin(relTup->t_data) &&
  			 ItemPointerEquals(&arg->typrel_tid, &relTup->t_self));
  
  	ReleaseSysCache(relTup);
--- 455,461 ----
  		elog(ERROR, "cache lookup failed for relation %u", arg->typ_relid);
  
  	/* If it has changed, the cached data is not valid */
! 	valid = (arg->typrel_xmin == HeapTupleGetRawXmin(relTup) &&
  			 ItemPointerEquals(&arg->typrel_tid, &relTup->t_self));
  
  	ReleaseSysCache(relTup);
*************** PLy_procedure_valid(PLyProcedure *proc, 
*** 476,482 ****
  		return false;
  
  	/* If the pg_proc tuple has changed, it's not valid */
! 	if (!(proc->fn_xmin == HeapTupleHeaderGetRawXmin(procTup->t_data) &&
  		  ItemPointerEquals(&proc->fn_tid, &procTup->t_self)))
  		return false;
  
--- 476,482 ----
  		return false;
  
  	/* If the pg_proc tuple has changed, it's not valid */
! 	if (!(proc->fn_xmin == HeapTupleGetRawXmin(procTup) &&
  		  ItemPointerEquals(&proc->fn_tid, &procTup->t_self)))
  		return false;
  
diff --git a/src/pl/plpython/plpy_typeio.c b/src/pl/plpython/plpy_typeio.c
new file mode 100644
index 0e04753..ce8c385
*** a/src/pl/plpython/plpy_typeio.c
--- b/src/pl/plpython/plpy_typeio.c
*************** PLy_input_tuple_funcs(PLyTypeInfo *arg, 
*** 143,149 ****
  			elog(ERROR, "cache lookup failed for relation %u", arg->typ_relid);
  
  		/* Remember XMIN and TID for later validation if cache is still OK */
! 		arg->typrel_xmin = HeapTupleHeaderGetRawXmin(relTup->t_data);
  		arg->typrel_tid = relTup->t_self;
  
  		ReleaseSysCache(relTup);
--- 143,149 ----
  			elog(ERROR, "cache lookup failed for relation %u", arg->typ_relid);
  
  		/* Remember XMIN and TID for later validation if cache is still OK */
! 		arg->typrel_xmin = HeapTupleGetRawXmin(relTup);
  		arg->typrel_tid = relTup->t_self;
  
  		ReleaseSysCache(relTup);
*************** PLy_output_tuple_funcs(PLyTypeInfo *arg,
*** 215,221 ****
  			elog(ERROR, "cache lookup failed for relation %u", arg->typ_relid);
  
  		/* Remember XMIN and TID for later validation if cache is still OK */
! 		arg->typrel_xmin = HeapTupleHeaderGetRawXmin(relTup->t_data);
  		arg->typrel_tid = relTup->t_self;
  
  		ReleaseSysCache(relTup);
--- 215,221 ----
  			elog(ERROR, "cache lookup failed for relation %u", arg->typ_relid);
  
  		/* Remember XMIN and TID for later validation if cache is still OK */
! 		arg->typrel_xmin = HeapTupleGetRawXmin(relTup);
  		arg->typrel_tid = relTup->t_self;
  
  		ReleaseSysCache(relTup);
